<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
<!-- cli-config.qdoc -->
  <title>config | Qbs Manual</title>
  <link rel="stylesheet" type="text/css" href="style/offline-simple.css" />
  <script type="text/javascript">
    document.getElementsByTagName("link").item(0).setAttribute("href", "style/offline.css");
    // loading style sheet breaks anchors that were jumped to before
    // so force jumping to anchor again
    setTimeout(function() {
        var anchor = location.hash;
        // need to jump to different anchor first (e.g. none)
        location.hash = "#";
        setTimeout(function() {
            location.hash = anchor;
        }, 0);
    }, 0);
  </script>
</head>
<body>
<div class="header" id="qtdocheader">
  <div class="main">
    <div class="main-rounded">
      <div class="navigationbar">
        <table><tr>
<td ><a href="index.html">Qbs Manual</a></td><td >config</td></tr></table><table class="buildversion"><tr>
<td id="buildversion" width="100%" align="right">Qbs 1.15.0</td>
        </tr></table>
      </div>
    </div>
<div class="content">
<div class="line">
<div class="content mainContent">
<p class="naviNextPrevious headerNavi">
</p><p/>
<div class="sidebar">
<div class="toc">
<h3><a name="toc">Contents</a></h3>
<ul>
<li class="level1"><a href="#synopsis">Synopsis</a></li>
<li class="level1"><a href="#description">Description</a></li>
<li class="level1"><a href="#options">Options</a></li>
<li class="level2"><a href="#op-op-op-op-settings-op-op-dir-op-lt-op-directory-op-gt-op"><code>--settings-dir &lt;directory&gt;</code></a></li>
<li class="level2"><a href="#op-op-op-op-list-op-op-op-lt-op-root-op-gt-op-op-op-op-op-op-op-op-op"><code>--list [&lt;root&gt; ..&#x2e;]</code></a></li>
<li class="level2"><a href="#op-op-op-op-unset-op-lt-op-key-op-gt-op"><code>--unset &lt;key&gt;</code></a></li>
<li class="level2"><a href="#op-op-op-op-keyword-export-keyword-op-lt-op-file-op-gt-op"><code>--export &lt;file&gt;</code></a></li>
<li class="level2"><a href="#op-op-op-op-import-op-lt-op-file-op-gt-op"><code>--import &lt;file&gt;</code></a></li>
<li class="level2"><a href="#op-op-op-op-user"><code>--user</code></a></li>
<li class="level2"><a href="#op-op-op-op-system"><code>--system</code></a></li>
<li class="level2"><a href="#op-op-op-op-help-op-op-op-op-h-op-op-op-op-op-op"><code>--help|-h|-?</code></a></li>
<li class="level1"><a href="#parameters">Parameters</a></li>
<li class="level2"><a href="#op-lt-op-key-op-gt-op"><code>&lt;key&gt;</code></a></li>
<li class="level1"><a href="#examples">Examples</a></li>
</ul>
</div>
<div class="sidebar-content" id="sidebar-content"></div></div>
<h1 class="title">config</h1>
<span class="subtitle"></span>
<!-- $$$cli-config.html-description -->
<div class="descr"> <a name="details"></a>
<a name="synopsis"></a>
<h2 id="synopsis">Synopsis</h2>
<pre class="cpp">

  qbs config <span class="operator">[</span><span class="operator">-</span><span class="operator">-</span>settings<span class="operator">-</span>dir <span class="operator">&lt;</span>directory<span class="operator">&gt;</span><span class="operator">]</span> <span class="operator">[</span><span class="operator">-</span><span class="operator">-</span>user<span class="operator">|</span><span class="operator">-</span><span class="operator">-</span>system<span class="operator">]</span> <span class="operator">[</span><span class="operator">-</span><span class="operator">-</span>list <span class="operator">[</span><span class="operator">&lt;</span>root<span class="operator">&gt;</span> <span class="operator">.</span><span class="operator">.</span><span class="operator">.</span><span class="operator">]</span><span class="operator">]</span>
             <span class="operator">[</span><span class="operator">-</span><span class="operator">-</span>unset <span class="operator">&lt;</span>key<span class="operator">&gt;</span><span class="operator">]</span> <span class="operator">[</span><span class="operator">-</span><span class="operator">-</span><span class="keyword">export</span> <span class="operator">&lt;</span>file<span class="operator">&gt;</span><span class="operator">]</span> <span class="operator">[</span><span class="operator">-</span><span class="operator">-</span>import <span class="operator">&lt;</span>file<span class="operator">&gt;</span><span class="operator">]</span>
  qbs config <span class="operator">[</span><span class="operator">-</span><span class="operator">-</span>settings<span class="operator">-</span>dir <span class="operator">&lt;</span>directory<span class="operator">&gt;</span><span class="operator">]</span> <span class="operator">[</span><span class="operator">-</span><span class="operator">-</span>user<span class="operator">|</span><span class="operator">-</span><span class="operator">-</span>system<span class="operator">]</span> <span class="operator">&lt;</span>key<span class="operator">&gt;</span>
  qbs config <span class="operator">[</span><span class="operator">-</span><span class="operator">-</span>settings<span class="operator">-</span>dir <span class="operator">&lt;</span>directory<span class="operator">&gt;</span><span class="operator">]</span> <span class="operator">[</span><span class="operator">-</span><span class="operator">-</span>user<span class="operator">|</span><span class="operator">-</span><span class="operator">-</span>system<span class="operator">]</span> <span class="operator">&lt;</span>key<span class="operator">&gt;</span> <span class="operator">&lt;</span>value<span class="operator">&gt;</span>

</pre>
<a name="description"></a>
<h2 id="description">Description</h2>
<p>Manages Qbs settings, such as preferences and profiles. You can list all keys and remove the specified key, as well as import settings from a file or export them to a file.</p>
<p>The second form of this command displays the specified <code>&lt;key&gt;</code>.</p>
<p>The third form sets the specified <code>&lt;key&gt;</code> with the specified <code>&lt;value&gt;</code>.</p>
<p>There are two sets of settings: The system-level settings affect all users, while the user-level settings are specific to the current user. By default, the read operations consider both sources. If the same key is present in both settings, then for list values, the system value is appended to the user value, while for other types of values the user-level one takes precedence. Write operations go to the user-level settings by default. Use the <code>--user</code> and <code>--system</code> options to change this behavior.</p>
<p><b>Note: </b>It is conceivable that the default system value of the <code>preferences.qbsSearchPaths</code> setting could pull in unwanted Qbs modules, in particular when doing cross-builds. In such a case, you can set <code>preferences.ignoreSystemSearchPaths</code> to exclude the search paths coming from the system settings. You'll typically do this for a specific profile:</p><pre class="cpp">

  $ qbs config profiles<span class="operator">.</span>myprofile<span class="operator">.</span>preferences<span class="operator">.</span>ignoreSystemSearchPaths <span class="keyword">true</span>

</pre>
<p>You can use the <a href="cli-config-ui.html">config-ui</a> command to open the Qbs Settings tool for managing settings in a hierarchical view.</p>
<p>For more information, see <a href="configuring.html">Configuring Profiles and Preferences</a>, <a href="qt-versions.html">Managing Qt Versions</a>, <a href="language-introduction.html#modules">Modules</a>, <a href="qbsmodules-qmlmodule.html">List of Modules</a>, and <a href="custom-modules.html">Custom Modules and Items</a>.</p>
<a name="options"></a>
<h2 id="options">Options</h2>
<a name="op-op-op-op-settings-op-op-dir-op-lt-op-directory-op-gt-op"></a>
<h3 id="op-op-op-op-settings-op-op-dir-op-lt-op-directory-op-gt-op"><code>--settings-dir &lt;directory&gt;</code></h3>
<p>Reads all settings (such as <a href="qml-qbslanguageitems-profile.html">profile</a> information) from the specified <code>&lt;directory&gt;</code>. If the directory does not exist, it will be created.</p>
<p>The default value is system-specific. For example:</p>
<ul>
<li>Linux: <code>$HOME/.config/QtProject/qbs</code></li>
<li>Windows: <code>%APPDATA%\QtProject\qbs</code></li>
<li><a href="nolink">macOS</a>: <code>$HOME/Library/Preferences/qbs</code></li>
</ul>
<a name="op-op-op-op-list-op-op-op-lt-op-root-op-gt-op-op-op-op-op-op-op-op-op"></a>
<h3 id="op-op-op-op-list-op-op-op-lt-op-root-op-gt-op-op-op-op-op-op-op-op-op"><code>--list [&lt;root&gt; ..&#x2e;]</code></h3>
<p>Lists keys under the key <code>&lt;root&gt;</code> or all keys if the root is not specified.</p>
<p>Possible values are:</p>
<ul>
<li><code>defaultProfile</code> is the default <a href="qml-qbslanguageitems-profile.html">profile</a> to use if a profile is not specified</li>
<li><code>preferences</code> accepts build preferences as second-level keys</li>
<li><code>profiles</code> accepts profile names as second-level keys</li>
</ul>
<a name="op-op-op-op-unset-op-lt-op-key-op-gt-op"></a>
<h3 id="op-op-op-op-unset-op-lt-op-key-op-gt-op"><code>--unset &lt;key&gt;</code></h3>
<p>Removes the specified <code>&lt;key&gt;</code>.</p>
<a name="op-op-op-op-keyword-export-keyword-op-lt-op-file-op-gt-op"></a>
<h3 id="op-op-op-op-keyword-export-keyword-op-lt-op-file-op-gt-op"><code>--export &lt;file&gt;</code></h3>
<p>Exports settings to the specified <code>&lt;file&gt;</code>.</p>
<a name="op-op-op-op-import-op-lt-op-file-op-gt-op"></a>
<h3 id="op-op-op-op-import-op-lt-op-file-op-gt-op"><code>--import &lt;file&gt;</code></h3>
<p>Imports settings from the specified <code>&lt;file&gt;</code>.</p>
<a name="op-op-op-op-user"></a>
<h3 id="op-op-op-op-user"><code>--user</code></h3>
<p>Causes read operations to display only the user-level settings, while the system-level settings are ignored. Write operations will target the user-level settings, which is also the default.</p>
<a name="op-op-op-op-system"></a>
<h3 id="op-op-op-op-system"><code>--system</code></h3>
<p>Read and write operations will consider only the system-level settings.</p>
<a name="op-op-op-op-help-op-op-op-op-h-op-op-op-op-op-op"></a>
<h3 id="op-op-op-op-help-op-op-op-op-h-op-op-op-op-op-op"><code>--help|-h|-?</code></h3>
<p>Displays help for the command.</p>
<a name="parameters"></a>
<h2 id="parameters">Parameters</h2>
<a name="op-lt-op-key-op-gt-op"></a>
<h3 id="op-lt-op-key-op-gt-op"><code>&lt;key&gt;</code></h3>
<p>Typically, a <code>&lt;key&gt;</code> consists of several levels separated by periods. The first level shows a <i>root</i> value, such as <i>preferences</i> or <i>profiles</i>. The root determines whether the second-level keys are build preferences or profile names. The lower level keys consist of a module name, followed by a property name.</p>
<a name="examples"></a>
<h2 id="examples">Examples</h2>
<p>Lists the existing profiles:</p>
<pre class="cpp">

  qbs config <span class="operator">-</span><span class="operator">-</span>list profiles

</pre>
<p>Shows the default profile:</p>
<pre class="cpp">

  qbs config defaultProfile

</pre>
<p><b>Note: </b>If no output is shown, the default profile used is the built-in profile <code>none</code>, which sets no properties.</p><p>Sets the profile called <code>gcc</code> as the base profile of the Qt profile called <code>myqt</code>:</p>
<pre class="cpp">

  qbs config profiles<span class="operator">.</span>myqt<span class="operator">.</span>baseProfile gcc

</pre>
<p>Adds the location of a custom module to your preferences, to make the module accessible in several projects:</p>
<pre class="cpp">

  qbs config preferences<span class="operator">.</span>qbsSearchPaths <span class="operator">/</span>usr<span class="operator">/</span>local<span class="operator">/</span>share<span class="operator">/</span>custom<span class="operator">-</span>qbs<span class="operator">-</span>extensions

</pre>
</div>
<!-- @@@cli-config.html -->
<p class="naviNextPrevious footerNavi">
</p>
        </div>
       </div>
   </div>
   </div>
</div>
<div class="footer">
   <p>
   <acronym title="Copyright">&copy;</acronym> 2020 The Qt Company Ltd.
   Documentation contributions included herein are the copyrights of
   their respective owners.<br/>    The documentation provided herein is licensed under the terms of the    <a href="http://www.gnu.org/licenses/fdl.html">GNU Free Documentation    License version 1.3</a> as published by the Free Software Foundation.<br/>    Qt and respective logos are trademarks of The Qt Company Ltd.     in Finland and/or other countries worldwide. All other trademarks are property
   of their respective owners. </p>
</div>
</body>
</html>
